
static char *backLines;
RasterClearBackScreen()
{
	backLines = GetBackLines();

#asm
	ld hl, (backLines)
	ld bc, 5*2
	add hl, bc
	ld de, 0

	ld a, 205-5-5
clearMemLoop:
	push af
	
	ld a, ( hl )
	inc hl
	push hl
	ld h, ( hl )
	ld l, a
	ld bc, 95
	add hl, bc
	di
	ld ( clearMemLoopSP + 1 ), sp
	ld sp, hl

	defs 47, &D5 ; 48 * PUSH DE
	
clearMemLoopSP:
	ld sp, 0
	ei

	pop hl
	inc hl

rasterCount:
	ld a, 2
	dec a
	or a
	jp nz, rasterCountEnd
	call Raster
rasterCountEnd:
	ld ( rasterCount + 1 ), a

	pop af
	dec a
	jp nz, clearMemLoop
#endasm
}

// OUT: char *nextCharsPtr
DrawChars( backLinesPtr, charsPtr )
	char *backLinesPtr;
	char *charsPtr;
{
#asm
	di

	pop iy
	pop ix
	pop hl

	; ix = blocksPtr
	; hl = backLinesPtr

	;db &ed, &ff

	push hl
	push ix
	push iy

	ei

	ld a, ( ix )
	or a
	ret z

	cp 159
	jp nz, noClearScreen

	inc ix
	push ix
	push hl
	call RasterClearBackScreen
	pop hl
	pop ix

noClearScreen:

	ld a, ( IsCharsetFlipped )
	or a
	jp z, setFlipXOpcodeNOP
	ld a, &4F ; LD C,A opcode
	jp setFlipXOpcodeEnd
setFlipXOpcodeNOP:
	xor a
setFlipXOpcodeEnd:
	ld ( flipXChar ), a

	ld de, ( CharsetPtr )
	ld ( charsetPtr + 1 ), de

	ld a, 41
	ld ( DrawCharsLineCount + 1 ), a

	ld b, 0

DrawCharsLoop:
	ld a, ( ix )
	inc ix
	
	cp 255
	jp z, DrawCharsEndOfLine

	; hl = lines ptr
	
	push hl

	push hl
	
	; bc = offsetX
	cp 159
	jp c, saveSprIndex
	sub 160
	ld ( incLastX + 1), a
	ld c, ( ix )
	inc ix
	jp endIncX
saveSprIndex:
	ld e, a
incLastX:
	ld a, 0
	inc a
	ld ( incLastX + 1 ), a	
	ld c, e
endIncX:

; de = sprite ptr
charsetPtr:
	ld hl, 0
	add hl, bc
	add hl, bc
	add hl, bc
	add hl, bc
	add hl, bc
	ex de, hl

	ld c, a

	ld a, 95
	sub c
flipXChar:
	ld c, a

	pop hl
	
	ld a, ( hl )
	inc hl
	ld h, ( hl )
	ld l, a
	add hl, bc

	ex de, hl

	ld c, 8

	; 1
	ld a, ( hl )
	inc hl
	ld ( de ), a
	ld a, d
	add a, c
	ld d, a	
	
	; 2
	ld a, ( hl )
	inc hl
	ld ( de ), a
	ld a, d
	add a, c
	ld d, a
	
	; 3
	ld a, ( hl )
	inc hl
	ld ( de ), a
	ld a, d
	add a, c
	ld d, a
	
	; 4
	ld a, ( hl )
	inc hl
	ld ( de ), a
	ld a, d
	add a, c
	ld d, a
	
	; 5
	ld a, ( hl )
	ld ( de ), a
	
	pop hl

	jp DrawCharsLoop

DrawCharsEndOfLine:

	call Raster

	ld c, 5*2
	add hl, bc

DrawCharsLineCount:
	ld a, 41
	dec a
	ld ( DrawCharsLineCount + 1 ), a
	jp nz, DrawCharsLoop

	push ix
	pop hl

	ld a, ( hl )
	cp &fe
	jp nz, terminatorNotFound_Chars
	ld hl, 0
terminatorNotFound_Chars:
#endasm
}