
#include "JumptableConfig.cxx"

// Clear Screen
ClearScreen()
{
#asm
	ld hl, ( ClearScreenFuncID )
	jp ( hl )
#endasm
}

// Clear Back Screen
ClearBackScreen()
{
#asm
	ld hl, ( ClearBackScreenFuncID )
	jp ( hl )
#endasm
}

// Unpack
Unpack( source, destination )
	char *source;
	char *destination;
{
#asm
	ld hl, ( UnpackFuncID )
	jp ( hl )
#endasm
}

// Sprite
InitSpriteFrame( )
{
#asm
	ld hl, ( InitSpriteFrameFuncID )
	jp ( hl )
#endasm
}

InitSpriteStack( stackBitplan1, stackBitplan2 )
	char *stackBitplan1;
	char *stackBitplan2;
{
#asm
	ld hl, ( InitSpriteStackFuncID )
	jp ( hl )
#endasm
}

DrawSpriteData( x, y, bitplan1, bitplan2 )
	char x;
	char y;
	char *bitplan1;
	char *bitplan2;
{
#asm	
	ld hl, ( DrawSpriteDataFuncID )
	jp ( hl )
#endasm
}

DrawSpriteDataScanline( x, y, bitplan1, bitplan2, bankScr, width, height, scanlineWidth )
	char x;
	char y;
	char *bitplan1;
	char *bitplan2;
	int bankScr;
	int width;
	int height;	
	int scanlineWidth;
{
#asm	
	ld hl, ( DrawSpriteDataScanlineFuncID )
	jp ( hl )
#endasm
}

DrawSpriteOpcodes( x, y, bitplan1, bitplan2 )
	char x;
	char y;
	char *bitplan1;
	char *bitplan2;
{
#asm	
	ld hl, ( DrawSpriteOpcodesFuncID )
	jp ( hl )
#endasm
}

RestoreBackground()
{
#asm
	ld hl, ( RestoreBackgroundFuncID )
	jp ( hl )
#endasm
}

DrawSpriteOpcodesKeepBackground( x, y, bitplan1, bitplan2 )
	char x;
	char y;
	char *bitplan1;
	char *bitplan2;
{
#asm
	ld hl, ( DrawSpriteOpcodesKeepBackgroundFuncID )
	jp ( hl )
#endasm
}

// Memory
memset( destination, value, length )
	char *destination;
	char value;
	int length;
{
#asm
	ld hl, ( memsetFuncID )
	jp ( hl )
#endasm
}

memcpy( destination, source, length )
	char *destination;
	char *source;
	int length;
{
#asm
	ld hl, ( memcpyFuncID )
	jp ( hl )
#endasm
}

// Gate Array
SetColor( pen, color )
	char pen;
	char color;
{
#asm
	ld hl, ( SetColorFuncID )
	jp ( hl )
#endasm
}

SetPalette( palette )
	char *palette;
{
#asm
	ld hl, ( SetPaletteFuncID )
	jp ( hl )
#endasm
}

SetMode( mode )
	char mode;
{
#asm
	ld hl, ( SetModeFuncID )
	jp ( hl )
#endasm
}

UpdateBank( bank )
	char bank;
{
#asm
	ld hl, ( UpdateBankFuncID )
	jp ( hl )
#endasm
}

SetBank( bank )
	char bank;
{
#asm
	ld hl, ( SetBankFuncID )
	jp ( hl )
#endasm
}

PushBank( bank )
	char bank;
{
#asm
	ld hl, ( PushBankFuncID )
	jp ( hl )
#endasm
}

PopBank()
{
#asm
	ld hl, ( PopBankFuncID )
	jp ( hl )
#endasm
}

// Flipping
FlipScreen()
{
#asm
	ld hl, ( FlipScreenID )
	jp ( hl )
#endasm
}

GetBackLines()
{
#asm
	ld hl, ( GetBackLinesID )
	jp ( hl )
#endasm
}

BringBackToFrontLines()
{
#asm
	ld hl, ( BringBackToFrontLinesID )
	jp ( hl )
#endasm
}

IsScreenFlipped()
{
#asm
	ld hl, ( IsScreenFlippedID )
	jp ( hl )
#endasm
}

GetTopBackVideoPtr()
{
#asm
	ld hl, ( GetTopBackVideoPtrID )
	jp ( hl )
#endasm
}

GetBottomBackVideoPtr()
{
#asm
	ld hl, ( GetBottomBackVideoPtrID )
	jp ( hl )
#endasm
}
