
#asm
 	org &5000

	ld sp, &80

	jp main
#endasm


#asm
LoadingScreenTopPCK:
#endasm
#include "LoadingScreen.bmp.topBin.cxx"

#asm
LoadingScreenBottomPCK:
#endasm
#include "LoadingScreen.bmp.bottomBin.cxx"

#asm
LoadingScreenPalette:
#endasm
#include "LoadingScreen.cpcbitmap.cxx"

#asm
FDCHighMemPCK:
#endasm
#include "FDC_HighMem.bin.cxx"

// Config
#include "Config.h"

#include "GateArray.cxx"
#include "WaitVBL.cxx"
#include "Interrupts.cxx"
#include "CRTC.cxx"
#include "FDC.cxx"

// Framework (Public)
#include "Unpack.cxx"

GetLoadingScreenTopPCKPtr()
{
#asm
	ld hl, LoadingScreenTopPCK
#endasm
}

GetLoadingScreenBottomPCKPtr()
{
#asm
	ld hl, LoadingScreenBottomPCK
#endasm
}

GetLoadingScreenPalettePtr()
{
#asm
	ld hl, LoadingScreenPalette
#endasm
}

GetFDCHighMemPCKPtr()
{
#asm
	ld hl, FDCHighMemPCK
#endasm
}

// Main
main()
{
	DisableInterrupts();

	PushBank( BANKC0 );

	SetCRTC( 6, 0 );

	Unpack( GetFDCHighMemPCKPtr(), 0xB800 );

	BeginFDC();

	WaitVBL();
	SetColor( 16, COLOR0 );	

	Unpack( GetLoadingScreenTopPCKPtr(), VIDEOSEGMENT8000 );
	
	SetCRTC( 1, CRTC_REG1 );
	SetCRTC( 2, CRTC_REG2 );
	SetCRTC( 7, CRTC_REG7 );
	SetCRTC( 9, CRTC_REG9 );
	SetCRTC( 4, CRTC_REG4 );

	SetCRTC( 12, 0x2C );
	SetCRTC( 13, 0x40 );

	SetMode( MODE0 );
	
	SetPalette( GetLoadingScreenPalettePtr() );

	Unpack( GetLoadingScreenBottomPCKPtr(), VIDEOSEGMENTC000 );

	SetCRTC( 6, CRTC_REG6 );		

	LoadFile("PHREAKS 001", 0xE00);

#asm
	jp &2800
#endasm
}
