
#asm
stackBitplan1:
	dw 0

stackBitplan2:
	dw 0

lastStackBitplan1:
	dw 0

lastStackBitplan2:
	dw 0
#endasm

InitSpriteFrame( )
{
#asm
	call asmGetBackLines
	ld ( linesPtr + 1 ), hl
	ld ( linesPtr_bg + 1 ), hl

	;call asmGetFrontLines
	;ld ( linesMaskPtr + 1 ), hl
#endasm
}

InitSpriteStack( stackBitplan1, stackBitplan2 )
	char *stackBitplan1;
	char *stackBitplan2;
{
#asm
	di
	
	pop ix
	
	; stackbitplan2
	pop hl
	ld ( hl ), 0
	dec hl
	ld ( hl ), 0
	dec hl
	ld ( hl ), 0
	dec hl
	ld ( hl ), 0
	dec hl
	ld ( stackBitplan2 ), hl

	; stackbitplan1
	pop hl
	ld ( hl ), 0
	dec hl
	ld ( hl ), 0
	dec hl
	ld ( hl ), 0
	dec hl
	ld ( hl ), 0
	dec hl
	ld ( stackBitplan1 ), hl


	ld a, (IsFlipped)
	or a
	jp z, setBitplan2

	ld hl, ( stackBitplan1 )
	ld ( bitplanStack_Start + 1 ), hl
	ld hl, ( lastStackBitplan1 )
	ld ( restoreBg_stack + 1 ), hl
	ld hl, lastStackBitplan1
	ld ( bitplanStackPtr + 1 ), hl
	jp endSetBitplan

setBitplan2:
	ld hl, (stackBitplan2 )
	ld ( bitplanStack_Start + 1 ), hl
	ld hl, ( lastStackBitplan2 )
	ld ( restoreBg_stack + 1 ), hl
	ld hl, lastStackBitplan2
	ld ( bitplanStackPtr + 1 ), hl
endSetBitplan:

	push hl
	push hl
	push ix

	ei
#endasm	
}

DrawSpriteData( x, y, bitplan1, bitplan2 )
	char x;
	char y;
	char *bitplan1;
	char *bitplan2;
{
#asm	
	di

	pop ix
	pop de
	pop de ; let's consider only bitplan1 is valid

	pop hl ; l = Y pos

	add hl, hl
	ld bc, ( linesPtr + 1 )
	add hl, bc
	ex de, hl
	; hl = bitplan1
	; de = linesPtr
		
	pop bc ; c = X pos
	ld ( spriteDataLoopX_posX + 1), bc

	push bc
	push hl
	push de
	push de
	push ix

	ei

	ld a, ( hl ) ; width
	ld ( spriteDataLoopX_width + 1 ), a
	inc hl
	ld a, ( hl ) ; a = height
	inc hl
	
spriteDataLoopY:
	
	ex de, hl

	ld c, ( hl )
	inc hl
	ld b, ( hl )
	inc hl

	push hl

	ld h, b
	ld l, c

spriteDataLoopX_posX:
	ld bc, 0
	add hl, bc

spriteDataLoopX_width:
	ld c, 0

	ex de, hl

	; db &ed, &ff

	ldir

	pop de
	
	dec a
	jp nz, spriteDataLoopY
	
#endasm
}

DrawSpriteDataScanline( x, y, bitplan1, bitplan2, bankScr, width, height, scanlineWidth )
	char x;
	char y;
	char *bitplan1;
	char *bitplan2;
	int bankScr;
	int width;
	int height;
	int scanlineWidth;
{
#asm	
	di

	pop ix
	pop hl
	ld ( scanlineWidth + 1 ), hl
	pop hl
	ld a, l
	ld ( spriteDataHeight + 1 ), a
	pop hl
	ld a, l
	ld ( spriteScanlineDataLoopX_width + 1 ), a
	pop hl
	ld a, l
	ld ( sprite_srcBank + 1 ), a
	
	pop de
	pop de ; let's consider only bitplan1 is valid

	pop hl ; l = Y pos

	add hl, hl
linesMaskPtr:
	ld bc, ( linesPtr + 1 )
	add hl, bc
	ex de, hl
	; hl = bitplan1
	; de = linesPtr
		
	pop bc ; c = X pos
	ld ( spriteScanlineDataLoopX_posX + 1), bc

	push bc
	push hl
	push de
	push de
	push de
	push de
	push de
	push de
	push ix

	ei

spriteDataHeight:
	ld a, 0
	
spriteScanlineDataLoopY:
	
	ex de, hl

	ld c, ( hl )
	inc hl
	ld b, ( hl )
	inc hl

	push hl

	ld h, b
	ld l, c

spriteScanlineDataLoopX_posX:
	ld bc, 0
	add hl, bc

	ex af, af'

	di

	ld bc, &7f00
	out (c), c

	exx
	ld d, &c0
sprite_srcBank:
	ld e, 0
	ld bc, &7f00
	exx

spriteScanlineDataLoopX_width:
	ld a, 0
	ld ixh, a

	ex de, hl

	push hl
spriteScanlineDataLoop_Draw:
	exx
	out (c), e
	exx
	ld a, (hl)
	inc hl
	exx
	out (c), d
	exx
	push hl

	or a
	jp z, postWrite

	ld l, a

testLeftPixel:
	and &AA
	jp nz, testRightPixel
	ld a, l
	and &55 ; keep right pixel
	ld l, a
	ld a, (de)
	and &AA
	or l
	jp drawSprPixel

testRightPixel:
	ld a, l
	and &55
	jp nz, drawPixelNoMerge
	ld a, l
	and &AA ; keep left pixel
	ld l, a
	ld a, (de)
	and &55
	or l
	jp drawSprPixel

drawPixelNoMerge:
	ld a, l

drawSprPixel:
	ld (de), a

postWrite:
	inc de
	
	pop hl

	dec ixh
	jp nz, spriteScanlineDataLoop_Draw

	pop hl
	
scanlineWidth:
	ld bc, 0
	add hl, bc
	
	pop de

	ei

	ex af, af'
	dec a
	jp nz, spriteScanlineDataLoopY
	
#endasm
}

DrawSpriteOpcodes( x, y, bitplan1, bitplan2 )
	char x;
	char y;
	char *bitplan1;
	char *bitplan2;
{
#asm	
	di

	pop iy

	; bitplan2
	pop hl
	ld ( jpBitplan2 + 1 ), hl

	; bitplan1
	pop hl
	ld ( jpBitplan1 + 1 ), hl

	; y
	pop hl
	add hl, hl
linesPtr:
	ld bc, 0
	add hl, bc
	
	; x
	pop de

	ld a, e
	srl a ; div 2	
	and &1
	or a

	ld ( endExecBitplan + 1 ), sp
	ld ix, endExecBitplan

	; db &ed, &ff

	ld b, 0
	ld c, e ; bc = x
jpBitplan1:
	jp z, 0
jpBitplan2:
	jp 0

endExecBitplan:
	ld sp, 0
	ei

	push hl
	push hl
	push hl
	push hl
	push iy
#endasm
}

RestoreBackground()
{
#asm
	di
	ld ( restoreBg_stackExec + 1 ), sp

	;db &ed, &ff

restoreBg_stack:
	ld sp, 0

restoreBg:
	pop de
	pop hl
	ld a, h
	or l
	jp z, restoreBgEnd
	ld (hl), d
	pop de
	pop hl
	ld a, h
	or l
	jp z, restoreBgEnd
	ld (hl), d
	pop de
	pop hl
	ld a, h
	or l
	jp z, restoreBgEnd
	ld (hl), d
	pop de
	pop hl
	ld a, h
	or l
	jp z, restoreBgEnd
	ld (hl), d
	jp restoreBg
restoreBgEnd:	

restoreBg_stackExec:
	ld sp, 0
	ei
#endasm
}

DrawSpriteOpcodesKeepBackground( x, y, bitplan1, bitplan2 )
	char x;
	char y;
	char *bitplan1;
	char *bitplan2;
{
#asm	
	di

	pop iy

	; bitplan2
	pop hl
	ld ( jpBitplan2_bg + 1 ), hl

	; bitplan1
	pop hl
	ld ( jpBitplan1_bg + 1 ), hl

	; y
	pop hl
	add hl, hl
linesPtr_bg:
	ld bc, 0
	add hl, bc

	; x
	pop de

	ld a, e
	srl a ; div 2	
	and &1
	or a

	ld ( endExecBitplan_stack + 1 ), sp
	ld ix, endExecBitplan_bg
	
	ld b, 0
	ld c, e ; bc = x
bitplanStack_Start:
	ld sp, 0

jpBitplan1_bg:
	jp z, 0
jpBitplan2_bg:
	jp 0

endExecBitplan_bg:

	;db &ed, &ff

bitplanStackPtr:
	ld de, 0
	ld hl, 0
	add hl, sp
	ex de, hl
	ld ( hl ), e
	inc hl
	ld ( hl ), d
	ld ( bitplanStack_Start + 1 ), sp

endExecBitplan_stack:
	ld sp, 0

	push hl
	push hl
	push hl
	push hl
	push iy

	ei
#endasm
}