
// StateOfTheArt Part

#asm
	org &E800 
	jp OnInit 
	jp OnPaint
	jp IsRunning
#endasm

#include "Config.h"
#include "DummyData.h"
#undef _BANKCONFIG_H_
#undef BANKCONFIG_C4
#undef BANKCONFIG_C4_SIZE
#undef DATASIZE
#include "Phreaks.h"
#include "JumpTablePart.cxx"

#include "Variables.cxx"
#include "Raster.cxx"
#include "DrawBlocks.cxx"
#include "Dance1.rawbmp.cxx"
#include "CustomExomizer.cxx"
#include "FlipCharset.cxx"
#include "ExoSetup.cxx"
#include "ManageBlocks.cxx"
#include "Record.cxx"
#include "Writer.cxx"

IsRunning()
{
	return 1;
}

#define PEN_BORDER 14
#define PEN_BODY 15

static int nbDrawTaches;

OnInit()
{	
	// Charset
	CharsetPtr = CODESEGMENTC000 + CODESEGMENTC000_SIZE - DANCE1RAWBMPCHARSETBINPCK_UNPACKEDSIZE;
	
	// Sprite Frame
	FrameSprTopLeftPtr = 0x3DD0;
	FrameSprTopRightPtr = CODESEGMENT4000;
	FrameSprBottomLeftPtr = FrameSprTopRightPtr + FRAMESPRTOPRIGHTBMPSPRZ801PCK_UNPACKEDSIZE;
	FrameSprBottomRightPtr = FrameSprBottomLeftPtr + FRAMESPRBOTTOMLEFTBMPSPRZ801PCK_UNPACKEDSIZE;
	
	// Dirt
	Dirt3Ptr = FrameSprBottomRightPtr + FRAMESPRBOTTOMRIGHTBMPSPRZ801PCK_UNPACKEDSIZE;
	Dirt4Ptr = Dirt3Ptr + DIRT3BMPSPRZ801PCK_UNPACKEDSIZE;
	Dirt5Ptr = Dirt4Ptr + DIRT4BMPSPRZ801PCK_UNPACKEDSIZE;
	Dirt6Ptr = Dirt5Ptr + DIRT5BMPSPRZ801PCK_UNPACKEDSIZE;

	Dirt1Ptr = Dirt6Ptr + DIRT6BMPSPRZ801PCK_UNPACKEDSIZE;
	Dirt2Ptr = Dirt1Ptr + DIRT1BMPSPRZ801PCK_UNPACKEDSIZE;
	
	// Sprites
	SpriteBlocksUnpackPtr = CODESEGMENT8000;
	ResetSpriteFiles();

	// Flip Charset
	FlipCharset();

	//ResetRasterFX();

	InitWriter();
	ResetWriter();
}

SetFXColor( colorBody, colorBorder )
	int colorBody;
	int colorBorder;
{
	PushBank( RECORDCPCBITMAPPALETTE_BANK );
	SetPalette( RECORDCPCBITMAPPALETTE_PTRINBANK );
	PopBank();

	SetColor( PEN_BODY, colorBody );
	SetColor( PEN_BORDER, colorBorder );
}

OnPaint()
{	
	InitSpriteFrame();

	showWriterCount--;
	if ( showWriterCount != 0 )
	{
		ShowWriter();

		doInitPal = 1;
	}
	else
	{	
		showWriterCount = 1;

		if ( flipCount == 0 )
		{			
			if ( frameCount == 1 )
			{			
				if ( firstTime == 0 )
				{
					NextRasterFX();
					firstTime = 1;
				}

				SetFXColor( COLOR25, COLOR24 );
			}
			/*else if ( ( frameCount == 15 ) && ( teteAnim == 2 ) )
			{
				//ResetWriter();
			}*/
			else if ( frameCount == 17 )
			{
				NextRasterFX();
				SetFXColor( COLOR11, COLOR14 );	
			}
			/*else if ( frameCount == 47 )
			{
				//ResetWriter();
			}*/
			else if ( frameCount == 49 )
			{
				NextRasterFX();
				SetFXColor( COLOR15, COLOR6 );
			}
			else if ( frameCount == 81 )
			{
				ResetWriter();
			}
			else if ( frameCount == 83 )
			{
				NextRasterFX();
				SetFXColor( COLOR13, COLOR10 );
			}
			/*else if ( frameCount == 115 )
			{
				//ResetWriter();
			}*/
			else if ( frameCount == 117 )
			{
				NextRasterFX();
				SetFXColor( COLOR16, COLOR7 );								
			}
			/*else if ( frameCount == 172 )
			{
				//ResetWriter();
			}*/
			else if ( frameCount == 174 )
			{
				NextRasterFX();
				SetFXColor( COLOR15, COLOR16 );			
			}
			else if ( frameCount == 194 )
			{
				ResetWriter();

				firstTime = 0;
			}
		}
		else
		{
			if ( frameCount == 1 )
			{			
				if ( firstTime == 0 )
				{
					NextRasterFX();
					firstTime = 1;
				}

				//NextRasterFX();
				SetFXColor( COLOR23, COLOR20 );
			}
			/*else if ( ( frameCount == 15 ) && ( teteAnim == 2 ) )
			{
				//ResetWriter();
			}*/
			else if ( frameCount == 17 )
			{
				NextRasterFX();
				SetFXColor( COLOR3, COLOR3 );				
			}
			/*else if ( frameCount == 47 )
			{
				//ResetWriter();
			}*/
			else if ( frameCount == 49 )
			{
				NextRasterFX();
				SetFXColor( COLOR15, COLOR16 );
			}
			else if ( frameCount == 81 )
			{
				ResetWriter();
			}
			else if ( frameCount == 83 )
			{
				NextRasterFX();
				SetFXColor( COLOR1, COLOR0 );
			}
			/*else if ( frameCount == 115 )
			{
				//ResetWriter();
			}*/
			else if ( frameCount == 117 )
			{
				NextRasterFX();
				SetFXColor( COLOR26, COLOR23 );
			}
			/*else if ( frameCount == 172 )
			{
				//ResetWriter();
			}*/
			else if ( frameCount == 174 )
			{
				NextRasterFX();
				SetFXColor( COLOR6, COLOR7 );
			}
			else if ( frameCount == 194 )
			{
				ResetWriter();		
			}
		}

		ManageCharacters();

		DrawRecordSprite();
	}
}
